package dynamic_data_structures;

public class TestArrayQueue {
	
	public static void main(String[] args) {
		ArrayQueue<Integer> aq = new ArrayQueue<Integer>(10);
		aq.print();
		aq.print2();
		for( int i=1; i<20; i+=2){
			aq.enqueue(i);
			aq.enqueue(i+1);
			aq.print();
			aq.print2();
			try {
				aq.dequeue();
			} catch (EmptyQueueException e) {
				System.out.println(e.getMessage());
			}
		}
		try {
			for( int i=1; i<10; i++){
				aq.dequeue();
			}
		} catch (EmptyQueueException e) {
			System.out.println(e.getMessage());
		}
		aq.print();
		aq.print2();
		for( int i=10; i<30; i+=2){
			aq.enqueue(i);
			aq.enqueue(i+1);
			aq.print();
			aq.print2();
			try {
				aq.dequeue();
			} catch (EmptyQueueException e) {
				System.out.println(e.getMessage());
			}
		}
		aq.print();
		aq.print2();
	}
}// end of TestArrayQueue
