package exceptions;

public class IllegalDateException extends Exception {
	
	private static final long serialVersionUID = 1L;
	
	int day;
	int month;
	int year;
	
	public IllegalDateException(int month, int day, int year) {
		this.month = month;
		this.day = day;
		this.year = year;
	}
	
	public IllegalDateException(String badNews, int day, int month, int year) {
		super(badNews);
		this.month = month;
		this.day = day;
		this.year = year;
	}
	
	public IllegalDateException(String badNews){
		super(badNews);
	}
}// end of class IllegalDateException
